#include <bits/stdc++.h>
using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, sum = 0;
    cin >> n;
    vector <long long> v(n), left(n), right(n);
    stack <long long> l, r;

    for (int i = 0; i < n; i++) cin >> v[i];

    for (int i = 0; i < n; i++) {
        while (!l.empty() && v[l.top()] < v[i]) l.pop();

        if (l.empty()) left[i] = -1;
        else left[i] = l.top();

        l.push(i);
    }

    for (int i = n - 1; i >= 0; i--) {
        while (!r.empty() && v[r.top()] < v[i]) r.pop();

        if (r.empty()) right[i] = v.size();
        else right[i] = r.top();

        r.push(i);
    }


    for (int i = 0; i < n; i++) {
        sum += (i - left[i]) * (right[i] - i) + (i - left[i]) * (n - right[i]) + (right[i] - i) * (left[i] + 1);
    }

    cout << sum << endl;
    return 0;

}
