#include <bits/stdc++.h>
using namespace std;

int a, b, k;

bool swapab, swapak;

void print(int x, int y, int z) {
    if (swapab) swap(a, b);
    if (swapak) swap(a, k);

    cout << x << ' ' << y << ' ' << z << '\n';
}

pair <int, int> get_2d_position(int num) {
    if (num < a) return {1, num + 1};

    int row, column = (num - a) / (b - 1);

    if (column % 2 == 0) row = 1 + (num - a) % (2 * b - 2);
    else row = b - 1 - ((num - a) % (b - 1));

    column = a - column - 1;

    return {row + 1, column + 1};
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int A, B, K;
    cin >> a >> b >> k;

    if (a * b * k % 2) {
        cout << "No";
        return 0;
    }

    if (a % 2 && k % 2 == 0) {
        swap(a, k);
        swapak = true;
    } else if (a % 2 && b % 2 == 0) {
        swap(a, b);
        swapab = true;
    }

    cout << "Yes\n";

    for (int i = 0; i < a * b; i++) {
        pair <int, int> pos = get_2d_position(i);

        if (i % 2 == 0) {
            for (int j = 1; j <= k; j++) print(pos.first, pos.second, j);
        } else {
            for (int j = k; j > 0; j--) print(pos.first, pos.second, j);
        }
    }

    cout << "1 1 1";

    return 0;

}
